﻿using WebApplication2.Models;
using System;
using System.Data;
using System.Data.OleDb;
using System.Diagnostics;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.DataVisualization;
using CsvHelper;

namespace WebApplication2.Controllers
{
    public class HomeController : Controller
    {
        
        public ActionResult Index()
        {
            GetData();
            return View();
        }

        
        public string GetData()
        {
            string strCSVFileName = Server.MapPath("~/App_Data/data.csv");

            using (var sr = new StreamReader(strCSVFileName))
            {
                var reader = new CsvReader(sr);
                IEnumerable<ChartRecord> records = reader.GetRecords<ChartRecord>();

                DataTable dtTable = records.ToDataTable();

                string strAccX =  "\"index\": {0}, \"parameterX\": {1}";
                string strAccY =  "\"index\": {0}, \"parameterY\": {1}";
                string strAccZ =  "\"index\": {0}, \"parameterZ\": {1}";
                string strGyroX = "\"index\": {0}, \"gyroX\" : {1}";
                string strGyroY = "\"index\": {0}, \"gyroY\" : {1}";
                string strGyroZ = "\"index\": {0}, \"gyroZ\" : {1}";

                string strPoints = string.Empty;

                ArrayList accX = new ArrayList(), 
                          accY = new ArrayList(), 
                          accZ = new ArrayList(), 
                          gyroX = new ArrayList(), 
                          gyroY = new ArrayList(),
                          gyroZ = new ArrayList();

                int i = 0;

                foreach (DataRow dr in dtTable.Rows)
                {
                    DateTime dtRowDate = DateTime.Parse(dr["DateTime"].ToString());
                    string strDate = string.Format("\"{0},{1},{2},{3},{4},{5}\"",dtRowDate.Year,
                                                                                       dtRowDate.Month,
                                                                                       dtRowDate.Day,
                                                                                       dtRowDate.Hour,
                                                                                       dtRowDate.Minute,
                                                                                       dtRowDate.Second);
                    accX.Add("{"+string.Format(strAccX, strDate, dr["AccX"].ToString())+ "}");
                    accY.Add("{" + string.Format(strAccY, strDate, dr["AccY"].ToString()) + "}");
                    accZ.Add("{" + string.Format(strAccZ, strDate, dr["AccZ"].ToString()) + "}");
                    gyroX.Add("{" + string.Format(strGyroX, strDate, dr["GyroX"].ToString()) + "}");
                    gyroY.Add("{" + string.Format(strGyroY, strDate, dr["GyroY"].ToString()) + "}");
                    gyroZ.Add("{" + string.Format(strGyroZ, strDate, dr["GyroZ"].ToString()) + "}");
                }

                strPoints = "{ \"points\":[" + string.Join(",", accX.ToArray()) + "], \"name\":\"paramerterX\"},";
                strPoints += "{ \"points\":[" + string.Join(",", accY.ToArray()) + "], \"name\":\"paramerterY\"},";
                strPoints += "{ \"points\":[" + string.Join(",", accZ.ToArray()) + "], \"name\":\"paramerterZ\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroX.ToArray()) + "], \"name\":\"gyroX\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroY.ToArray()) + "], \"name\":\"gyroY\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroZ.ToArray()) + "], \"name\":\"gyroZ\"}";

                strPoints = "["+ strPoints + "]";

                return (strPoints);
            }
        }

        public string GetData(int numberOfRecords)
        {
            string strCSVFileName = Server.MapPath("~/App_Data/data.csv");

            using (var sr = new StreamReader(strCSVFileName))
            {
                var reader = new CsvReader(sr);
                IEnumerable<ChartRecord> records = reader.GetRecords<ChartRecord>();

                DataTable dtTable = records.ToDataTable();

                string strAccX = "\"index\": {0}, \"parameterX\": {1}";
                string strAccY = "\"index\": {0}, \"parameterY\": {1}";
                string strAccZ = "\"index\": {0}, \"parameterZ\": {1}";
                string strGyroX = "\"index\": {0}, \"gyroX\" : {1}";
                string strGyroY = "\"index\": {0}, \"gyroY\" : {1}";
                string strGyroZ = "\"index\": {0}, \"gyroZ\" : {1}";

                string strPoints = string.Empty;

                ArrayList accX = new ArrayList(),
                          accY = new ArrayList(),
                          accZ = new ArrayList(),
                          gyroX = new ArrayList(),
                          gyroY = new ArrayList(),
                          gyroZ = new ArrayList();
                numberOfRecords = numberOfRecords > dtTable.Rows.Count ? dtTable.Rows.Count : numberOfRecords;
                for(int i=0; i<numberOfRecords; i++)
                {
                    DataRow dr = dtTable.Rows[i];
                    DateTime dtRowDate = DateTime.Parse(dr["DateTime"].ToString());
                    string strDate = string.Format("\"new Date({0},{1},{2},{3},{4},{5})\"", dtRowDate.Year,
                                                                                       dtRowDate.Month,
                                                                                       dtRowDate.Day,
                                                                                       dtRowDate.Hour,
                                                                                       dtRowDate.Minute,
                                                                                       dtRowDate.Second);
                    accX.Add("{" + string.Format(strAccX, strDate, dr["AccX"].ToString()) + "}");
                    accY.Add("{" + string.Format(strAccY, strDate, dr["AccY"].ToString()) + "}");
                    accZ.Add("{" + string.Format(strAccZ, strDate, dr["AccZ"].ToString()) + "}");
                    gyroX.Add("{" + string.Format(strGyroX, strDate, dr["GyroX"].ToString()) + "}");
                    gyroY.Add("{" + string.Format(strGyroY, strDate, dr["GyroY"].ToString()) + "}");
                    gyroZ.Add("{" + string.Format(strGyroZ, strDate, dr["GyroZ"].ToString()) + "}");
                }

                strPoints = "{ \"points\":[" + string.Join(",", accX.ToArray()) + "], \"name\":\"paramerterX\"},";
                strPoints += "{ \"points\":[" + string.Join(",", accY.ToArray()) + "], \"name\":\"paramerterY\"},";
                strPoints += "{ \"points\":[" + string.Join(",", accZ.ToArray()) + "], \"name\":\"paramerterZ\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroX.ToArray()) + "], \"name\":\"gyroX\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroY.ToArray()) + "], \"name\":\"gyroY\"},";
                strPoints += "{ \"points\":[" + string.Join(",", gyroZ.ToArray()) + "], \"name\":\"gyroZ\"}";

                strPoints = "[" + strPoints + "]";

                return (strPoints);
            }
        }

        [HttpPost]
        public JsonResult chart(int intNumberOfRecords)
        {
            string allText = GetData(intNumberOfRecords);
            //Set MaxJsonLength programatically to avoid restriction
            return new JsonResult() { MaxJsonLength = Int32.MaxValue, Data = allText };
        }

        [HttpPost]
        public ContentResult chartdata(int intNumberOfRecords)
        {            
            string allText = GetData(intNumberOfRecords);
            return new ContentResult() { Content = allText, ContentType = "application/json" };
        }

        public ActionResult ChartPartialView()
        {
            return PartialView();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }

    }

 public class ChartRecord
    {
        public  string AccX {get; set;}
        public string AccY{get; set;}
        public string AccZ{get; set;}
        public string GyroX{get; set;}
        public string GyroY{get;set;}
        public string GyroZ{get; set;}
        public string DateTime {get; set;}
        public string Index {get; set;}
    }

    public static class Utils
    {
        public static DataTable ToDataTable<T>(this IEnumerable<T> items)
        {
            var tb = new DataTable(typeof(T).Name);

            PropertyInfo[] props = typeof(T).GetProperties(BindingFlags.Public | BindingFlags.Instance);

            foreach (var prop in props)
            {
                tb.Columns.Add(prop.Name, prop.PropertyType);
            }

            foreach (var item in items)
            {
                var values = new object[props.Length];
                for (var i = 0; i < props.Length; i++)
                {
                    values[i] = props[i].GetValue(item, null);
                }

                tb.Rows.Add(values);
            }

            return tb;
        }
    }
}